#include <AccelStepper.h>
#include "IRLibAll.h"
#define HALFSTEP 8

// KONSTRUKTOR für den linken Motor
  #define motorLinksPin1  3     // IN1 auf dem ULN2003 Treiber für den linken Motor
  #define motorLinksPin2  4     // IN2 -"- 
  #define motorLinksPin3  5     // IN3 -"- 
  #define motorLinksPin4  6     // IN4 -"-

// KONSTRUKTOR für den rechten Motor
  #define motorRechtsPin1  8     // IN1 auf dem ULN2003 Treiber für den rechten Motor
  #define motorRechtsPin2  9     // IN2 -"- 
  #define motorRechtsPin3  10     // IN3 -"- 
  #define motorRechtsPin4  11     // IN4 -"-

// DEFINIEREN der Fernbedienungsinfrarotsignale

  #define RIGHT 91
  #define RIGHT2 65627
  #define LEFT 90
  #define LEFT2 65626
  #define UP 88
  #define UP2 65624
  #define DOWN 89
  #define DOWN2 65625

// INITIALISIERUNG der Reihenfolge IN1-IN3-IN2-IN4 in der die Elektromagneten der Motoren mit Strom versorgt werden
  AccelStepper motorL(HALFSTEP, motorLinksPin1, motorLinksPin3, motorLinksPin2, motorLinksPin4);
  AccelStepper motorR(HALFSTEP, motorRechtsPin1, motorRechtsPin3, motorRechtsPin2, motorRechtsPin4);

//Reciever und Decoder erstellen
  IRrecvPCI myReceiver(2); //create receiver and pass pin number
  IRdecodeRC6 myDecoder;   //create decoder
  
//GLOBALE VARIABLEN
  long geschwindigkeit = 1000;    //das Datenformat wird von den Funktionen der Bibliothek verlangt

void setup() {
 Serial.begin(9600);
 motorL.setMaxSpeed(1000.0);     //diese Daten sind wichtig für die korrekte Bewegung der Motoren
 motorL.setAcceleration(100.0);

 motorR.setMaxSpeed(1000.0);
 motorR.setAcceleration(100.0); 

 myReceiver.enableIRIn(); // Start the reciever
}

//Funktionen für die Vor- und Zurückdrehung des LINKEN Motors
void uhrzeigersinnL() {
  if (geschwindigkeit < 0) {
   geschwindigkeit=-geschwindigkeit;
  } 
  motorL.setSpeed(geschwindigkeit);
  motorL.runSpeed();
  motorL.run();
  
}
void gegenUhrzeigersinnL() {
  if (geschwindigkeit > 0) {
    motorL.setSpeed(-geschwindigkeit);  
  } else {
    motorL.setSpeed(geschwindigkeit);
  }
        
  motorL.runSpeed();
  motorL.run();
  
}

//Funktionen für die Vor- und Zurückdrehung des RECHTEN Motors
void uhrzeigersinnR() {
  if (geschwindigkeit < 0) {
    geschwindigkeit=-geschwindigkeit; 
  } 
 motorR.setSpeed(geschwindigkeit); 
  motorR.runSpeed();
  motorR.run();
  
}
void gegenUhrzeigersinnR() {
  if (geschwindigkeit > 0) {
    motorR.setSpeed(-geschwindigkeit);  
  } else {
    motorR.setSpeed(geschwindigkeit);
  }                  
  motorR.runSpeed();
  motorR.run();
}

//Funktionen für die Bewegung des Roboters
void rechtsdrehung(){
  //Es wird eine for-Schleife mit 30000 Durchläufen eingebaut,
  //damit genug steps gesteppt werden. Dies entspricht etwa einer Zehntelumdrehung
  for(int i=0;i<5000;i++){
    gegenUhrzeigersinnL();
    uhrzeigersinnR();                    
  }
}

void linksdrehung(){
  for(int i=0;i<5000;i++){
  uhrzeigersinnL();
  gegenUhrzeigersinnR();                      
  }
}

void vorwaerts(){
  for(int i=0;i<5000;i++){
  uhrzeigersinnL();
  uhrzeigersinnR();                      
  }
}

void rueckwaerts(){
  for(int i=0;i<5000;i++){
  gegenUhrzeigersinnL();
  gegenUhrzeigersinnR();                      
  }
}

void loop() {
  // put your main code here, to run repeatedly:
  if (myReceiver.getResults()) {
     myDecoder.decode(); 
   myReceiver.enableIRIn();
     switch(myDecoder.value){
      case RIGHT:rechtsdrehung();
      break;
      case RIGHT2:rechtsdrehung();
      break;                  
      case LEFT:linksdrehung();
      break;
      case LEFT2:linksdrehung();
      break;
      case UP:vorwaerts();
      break;
      case UP2:vorwaerts();
      break;
      case DOWN: rueckwaerts();  
      break;
      case DOWN2: rueckwaerts();
      break;     
     }
     

  }    
  
  

 
}
